SET TERM ^ ;

ALTER PROCEDURE GET_JCALC_SUM_NUCH_UDR_DIFF (
    ID_SOTR INTEGER,
    ID_SFIN INTEGER)
RETURNS (
    ID_SOTRUDNIK INTEGER,
    SUM_NUCH DOUBLE PRECISION,
    SUM_UDR DOUBLE PRECISION,
    SUM_DIFF DOUBLE PRECISION)
AS
DECLARE VARIABLE ID_SNU_VAL INTEGER;
DECLARE VARIABLE SUM_SNU_VAL DOUBLE PRECISION;
begin
if (id_sfin is null) then
begin
  sum_nuch = 0;
  for select distinct
             jczp.id_sotrudnik,jczp.id_snu,
             (coalesce((select sumsnu from getsumsnu(jczp.id_sotrudnik,jczp.id_snu)),0) ) as sumsnu
      from journalcalczp jczp
           left join sotrudnik sotr on sotr.id_sotrudnik = jczp.id_sotrudnik
      where
             codesnu > 2000
         and jczp.id_sotrudnik = :id_sotr
  into :id_sotrudnik,:id_snu_val,:sum_snu_val
  do begin
      sum_nuch = sum_nuch + coalesce(sum_snu_val,0);
     end
     
  sum_udr = 0;
  for select distinct
             jczp.id_sotrudnik,jczp.id_snu,
             (coalesce((select sumsnu from getsumsnu(jczp.id_sotrudnik,jczp.id_snu)),0) ) as sumsnu
      from journalcalczp jczp
           left join sotrudnik sotr on sotr.id_sotrudnik = jczp.id_sotrudnik
      where
             codesnu < 2000
         and jczp.id_sotrudnik = :id_sotr
  into :id_sotrudnik,:id_snu_val,:sum_snu_val
  do begin
     sum_udr = sum_udr + coalesce(sum_snu_val, 0);
     end
end
else
begin
  sum_nuch=0;
for select   distinct
             jczp.id_sotrudnik,jczp.id_snu,
             ( coalesce((select sumsnu from getsumsnu_ex(jczp.id_sotrudnik,jczp.id_snu,:id_sfin)),0) ) as sumsnu
      from journalcalczp jczp
           left join sotrudnik sotr on sotr.id_sotrudnik = jczp.id_sotrudnik
      where
             codesnu > 2000
         and jczp.id_sotrudnik = :id_sotr and jczp.id_sours=:id_sfin
  into :id_sotrudnik,:id_snu_val,:sum_snu_val
  do begin
      sum_nuch = sum_nuch +coalesce(sum_snu_val,0);
     end
     
  sum_udr =0;
  for select distinct
             jczp.id_sotrudnik,jczp.id_snu,
             ( coalesce((select sumsnu from getsumsnu_ex(jczp.id_sotrudnik,jczp.id_snu,:id_sfin)),0) ) as sumsnu
      from journalcalczp jczp
           left join sotrudnik sotr on sotr.id_sotrudnik = jczp.id_sotrudnik
      where
             codesnu < 2000
         and jczp.id_sotrudnik = :id_sotr and jczp.id_sours=:id_sfin
  into :id_sotrudnik,:id_snu_val,:sum_snu_val
  do begin
     sum_udr = sum_udr+ coalesce(sum_snu_val, 0);
     end


end


  sum_diff = coalesce(sum_nuch,0) - coalesce( sum_udr,0);


  suspend;
end

^

SET TERM ; ^


